/////////////////////////////////////////////////////////////
////// GDXlib.c
////// Written by:
//////    Michael Gibson
//////    (c)2004-2007 GPL 
//
//Copyright (C) 2004 - 2007 Michael Gibson 
//
//This library is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public
//License as published by the Free Software Foundation; either
//version 2.1 of the License, or (at your option) any later version.
//
//This software is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//General Public License for more details.
//
//You should have received a copy of the GNU General Public
//License along with this software; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

///////////////////////////////////////////////////////////

#include<X11/Xutil.h>
#include "images/rn.xpm"
#include "images/rn2.xpm"
#include <string.h>

//settings for background images
   GC            gcP;
   GC            gcP_label[640];
   GC            gcP_menu;

   XpmAttributes attributes_bg;
   int           imageh,imagew;
   int           background_pixmap=0;
   int           backgroundlabel_pixmap[640]={0};

// range for menu
   int           pulldown_menuheight[640]={0};

//for button images 
   GC            gcpixmap1,gcpixmap2;

// for widgets that have callbacks
typedef struct {
        void (*user_function)();
        }gdx_widget;

typedef struct {
        void (*user_function2)();
        }gdx_widget2;

typedef struct {
        void (*user_function3)();
        }gdx_widget3;

typedef struct {
        void (*user_function4)();
        }gdx_widget4;

static gdx_widget gdx_Array[640];
static gdx_widget2 gdx_Array2[640];
static gdx_widget3 gdx_Array3[640];
static gdx_widget4 gdx_Array4[640];

// text based widgets
struct gdx_text_struct {
       int focus[640];
       char string[640][640];
};

// for widgets that are dynamic with sub objects
struct gdx_widget_struct {
        int hilitepos[640];
        int position[640];
        //something selected in widget
        int selected[640];
        //an array of characters in a string, in an array of strings in a list, in an array of lists. 
        char item[640][640][640];
        };

struct gdx_graph_struct {
        int perc[640];
        };


// gdx_selectlist is a dynamic widget with sub objects
struct gdx_widget_struct gdx_selectlist_obj;

struct gdx_graph_struct gdx_pie_obj;

struct gdx_widget_struct gdx_chkbutton_obj; //check button

struct gdx_widget_struct gdx_lbutton_obj;   //light button

struct gdx_text_struct gdx_textentry_obj;

/////////////////////////////////////////
//
////////////////////////////////////////

gdx_setfunction(int id, void (*user_function)() ){

  gdx_Array[id].user_function=user_function;

}

gdx_setfunction2(int id, void (*user_function2)() ){

  gdx_Array2[id].user_function2=user_function2;

}

//menu item 
gdx_setfunction3(int id, void (*user_function3)() ){

  gdx_Array3[id].user_function3=user_function3;

}

//gdx image button
gdx_setfunction4(int id, void (*user_function4)() ){

  gdx_Array4[id].user_function4=user_function4;

}


////////////////////////////////////////
//
///////////////////////////////////////
gdx_ExecCallback (int id)
{
    (gdx_Array[id].user_function)();
}

gdx_ExecCallback2 (int id)
{
    (gdx_Array2[id].user_function2)();
}

//menu item
gdx_ExecCallback3 (int id)
{
    (gdx_Array3[id].user_function3)();
}

//image button
gdx_ExecCallback4 (int id)
{
    (gdx_Array4[id].user_function4)();
}



char numberstring[640][640];
int place[640]={0,0,0,0,0,0,0,0,0,0,0,0};
int windowtile,labeltile[640];

/////////////////////////////////////////
//
////////////////////////////////////////

void gdx_main(){

  int loop,loop2,loop3;
  char pietext[15];
  KeySym key;
  char text[640],text2[640];
  char mac_test;
  int  PC_key=0;

  //first lets create a special gcp for menu 
  //This is for cosmetics



     XGCValues PM_prop;
     Pixmap mask, pm, pmP;

     attributes_bg.valuemask = XpmColormap;
     attributes_bg.x_hotspot = 0;
     attributes_bg.y_hotspot = 0;
     attributes_bg.depth = DefaultDepth(display, DefaultScreen(display));;
     attributes_bg.colormap = DefaultColormap(display, DefaultScreen(display));

     PM_prop.function = GXcopy;
     PM_prop.plane_mask = AllPlanes;
     PM_prop.foreground = 0;


     gcP_menu = XCreateGC(display, window2, GCForeground|GCFunction|GCPlaneMask, &PM_prop);

     XpmReadFileToPixmap(display,window2,"images/menu_image.xpm",&pmP,&mask,&attributes_bg);

     XSetFillStyle(display, gcP_menu, FillTiled);
     XSetTile(display, gcP_menu, pmP);




  while (1) { //Loop forever,  examining each event.

      if(gdx_window_status==0) break;  //if window status is 0 the break out of window display


      if(GDX_event_flag==1){ //Non X11 event

           /// text entry
           for(loop=0;loop<global_textentry_num;loop++){ //do each text entry
                 if(global_textentry_type[loop]==0){
                   for(loop2=2;loop2<15;loop2++){
                     XDrawLine(display,window2,global_pen2,global_textentry_x[loop]+2,global_textentry_y[loop]+loop2,
                                               global_textentry_x[loop]+global_textentry_width[loop],global_textentry_y[loop]+loop2);
                   }
                   XDrawString(display,window2,global_pen,global_textentry_x[loop]+6,global_textentry_y[loop]+12,
                               gdx_textentry_obj.string[loop],strlen(gdx_textentry_obj.string[loop]));
                 }//correct type to alter

            }//end text entry

        GDX_event_flag=0; //reset GDX event
      }


      XNextEvent(display, &global_event);  //grab event

        if (global_event.type == MotionNotify){ // mouse moved


           /// menu bar
           /// if in the menu bar area (20 pixels or less)
           /// and
           /// There is at least 1 menubar
           /// and 
           /// mouse being moved in 'root' window (window2)
           if(global_event.xmotion.y <= 20 && global_menubar_num == 1 && global_event.xmotion.window==window2){ // mouse is on top and moving in root window

              for(loop=0;loop<global_menu_num;loop++){ //do each menu

                /// if mouse is being moved inside of starting x cord of the menu
                /// and
                /// the mouse is being moved inside of the ending xcord or the menu
                /// and
                /// mouse is being moved in the 'root' window (window2);
                if(global_event.xmotion.x >= global_menu_x[loop] && global_event.xmotion.x <= global_menu_x2[loop] && global_event.xmotion.window==window2){
                  for(loop2=0;loop2<18;loop2++){
                    XDrawLine(display,window2,global_pen6,global_menu_x[loop]-1,loop2,global_menu_x2[loop],loop2);
                  }
                  XDrawString(display,window2,global_pen2, global_menu_x[loop],12, global_menu_label[loop],strlen(global_menu_label[loop])); 
                  XMapWindow(display, pulldown[loop]); //show menu 

                }

                // if mouse on menu bar and less than menu or grater than menu don't display menu 
                if(global_event.xmotion.x <= global_menu_x[loop] || global_event.xmotion.x >= global_menu_x2[loop]){
                  for(loop2=0;loop2<18;loop2++){
                    //XDrawLine(display,window2,global_pen5,global_menu_x[loop]-1,loop2,global_menu_x2[loop],loop2);
                    XDrawLine(display,window2,gcP_menu,global_menu_x[loop]-1,loop2,global_menu_x2[loop],loop2);
                  }
                  XDrawString(display,window2,global_pen, global_menu_x[loop],12, global_menu_label[loop],strlen(global_menu_label[loop]));
                  XUnmapWindow(display,pulldown[loop]);
                }
              }
           }

          if(global_event.xmotion.y >= 20 && global_menubar_num == 1 && global_event.xmotion.window==window2){ // mouse is on top and moving in root window

              for(loop=0;loop<global_menu_num;loop++){ //do each menu

                //
                if(global_event.xmotion.x <= global_menu_x[loop] || global_event.xmotion.x >= global_menu_x2[loop] ||
                   global_event.xmotion.y >= pulldown_menuheight[loop]){                                           
                  for(loop2=0;loop2<18;loop2++){                          
                    //XDrawLine(display,window2,global_pen5,global_menu_x[loop]-1,loop2,global_menu_x2[loop],loop2);
                    XDrawLine(display,window2,gcP_menu,global_menu_x[loop]-1,loop2,global_menu_x2[loop],loop2);
                  }
                  XDrawString(display,window2,global_pen, global_menu_x[loop],12, global_menu_label[loop],strlen(global_menu_label[loop]));
                  XUnmapWindow(display,pulldown[loop]);
                }
              }  
           }



         /// menu items
         for(loop=0;loop<global_menu_num;loop++){ //do each menu

           if(global_event.xmotion.window==pulldown[loop]){ // mouse is menu window

             for(loop2=0;loop2<global_menuitem_num;loop2++){ //do each menu item
              if(global_event.xmotion.y <= global_menuitem_y[loop2] && 
                 global_event.xmotion.y >= global_menuitem_y[loop2]-10 &&
                 global_menuitem_parent[loop2]==loop){
                  for(loop3=0;loop3<12;loop3++){
                    XDrawLine(display,pulldown[loop],global_pen6,1,global_menuitem_y[loop2]-10+loop3,98,global_menuitem_y[loop2]-10+loop3);
                  }
                  XDrawString(display,pulldown[loop],global_pen2,2,global_menuitem_y[loop2],global_menuitem_label[loop2],strlen(global_menuitem_label[loop2]));
               }
              
              if(global_menuitem_parent[loop2]==loop){
                if(global_event.xmotion.y >= global_menuitem_y[loop2] || global_event.xmotion.y <= global_menuitem_y[loop2]-10){
                  for(loop3=0;loop3<12;loop3++){
                    //XDrawLine(display,pulldown[loop],global_pen5,1,global_menuitem_y[loop2]-10+loop3,98,global_menuitem_y[loop2]-10+loop3);
                    XDrawLine(display,pulldown[loop],global_pen4,1,global_menuitem_y[loop2]-10+loop3,98,global_menuitem_y[loop2]-10+loop3);
                    //XDrawLine(display,pulldown[loop],gcP_menu,1,global_menuitem_y[loop2]-10+loop3,98,global_menuitem_y[loop2]-10+loop3);
                  }
                  XDrawString(display,pulldown[loop],global_pen,2,global_menuitem_y[loop2],global_menuitem_label[loop2],strlen(global_menuitem_label[loop2]));
               }
             }

              }
            }
           }
        } 
///// time to do the keyboards... :)
        if (global_event.type == KeyPress){ // keyboard pressed
           /// text entry
           for(loop=0;loop<global_textentry_num;loop++){ //do each text entry
             if(global_textentry_me[loop] >= place[loop] && gdx_textentry_obj.focus[loop]==1){  //add character if room and in focus
               //printf("'%c' \n", XKeycodeToKeysym(display, global_event.xkey.keycode, 0));
               mac_test = XKeycodeToKeysym(display, global_event.xkey.keycode, 0);
               PC_key=0;
               if(global_event.xkey.keycode != 36  &&  // Enter
                  global_event.xkey.keycode != 9   &&  // Esc
                  global_event.xkey.keycode != 23  &&  // TAB
                  global_event.xkey.keycode != 66  &&  // Caps Lock
                  global_event.xkey.keycode != 50  &&  // Left Shift
                  global_event.xkey.keycode != 113 &&  // Right alt
                  global_event.xkey.keycode != 62  &&  // Right shift
                  global_event.xkey.keycode != 64  &&  // Left alt
                  global_event.xkey.keycode != 109 &&  // Right Ctrl
                  global_event.xkey.keycode != 37  &&  // Left Ctrl
                  global_event.xkey.keycode != 98  &&  // UP
                  global_event.xkey.keycode != 104 &&  // DOWN
                  global_event.xkey.keycode != 100 &&  // LEFT Arrow
                  global_event.xkey.keycode != 102 &&  // RIGHT Arrow
                  global_event.xkey.keycode != 22  &&  // PC Back Space
                  global_event.xkey.keycode != 59      // Mac Back Space also ',' on PC
                 ){
                 PC_key=1;
                 place[loop]=place[loop] + 6;
                 XLookupString(&global_event.xkey,text,255,&key,0);
                 sprintf(text2,"%c",text[0]);
                 if(global_textentry_type[loop]==0)XDrawString(display,window2,global_pen,global_textentry_x[loop]+place[loop],global_textentry_y[loop]+12,text2,1);
                 if(global_textentry_type[loop]==1)XDrawString(display,window2,global_pen,global_textentry_x[loop]+place[loop],global_textentry_y[loop]+12,"*",1);
                 strcat(numberstring[loop],text2);
                 if(mac_test==',')PC_key=0;
               }
               if(PC_key==0 && mac_test >= ' ' && mac_test <='~'){
                 place[loop]=place[loop] + 6;
                 XLookupString(&global_event.xkey,text,255,&key,0);
                 sprintf(text2,"%c",text[0]);
                 if(global_textentry_type[loop]==0)XDrawString(display,window2,global_pen,global_textentry_x[loop]+place[loop],global_textentry_y[loop]+12,text2,1);
                 if(global_textentry_type[loop]==1)XDrawString(display,window2,global_pen,global_textentry_x[loop]+place[loop],global_textentry_y[loop]+12,"*",1);
                 strcat(numberstring[loop],text2);
                 PC_key=0;
               }
               if((global_event.xkey.keycode == 22 && mac_test != 'e' ) || (mac_test!=','&&global_event.xkey.keycode == 59 && PC_key!=1)){  // Back Space 
                 place[loop]=place[loop] - 6;
                 if(place[loop]<=0)place[loop]=0;
                 for(loop2=2;loop2<15;loop2++){
                    XDrawLine(display,window2,global_pen2,global_textentry_x[loop]+2,global_textentry_y[loop]+loop2,
                              global_textentry_x[loop]+global_textentry_width[loop],global_textentry_y[loop]+loop2);
                 }

                 numberstring[loop][(strlen(numberstring[loop])-1)]='\0';
                 if(global_textentry_type[loop]==0){
                   XDrawString(display,window2,global_pen,global_textentry_x[loop]+6,global_textentry_y[loop]+12,
                               numberstring[loop],strlen(numberstring[loop]));
                 }

                 if(global_textentry_type[loop]==1){
                   XDrawString(display,window2,global_pen,global_textentry_x[loop]+6,global_textentry_y[loop]+12,
                               "****************",place[loop]/6);
                 }

               }// end back space PC 
             strcpy(gdx_textentry_obj.string[loop],numberstring[loop]);
            }
           }//end textentry for loop
      }//end keyboard


      if (global_event.type == ButtonPress){


        //text entry focus
        for(loop=0;loop<global_textentry_num;loop++){
           if(global_event.xbutton.x >= global_textentry_x[loop]){
             if(global_event.xbutton.x <= global_textentry_x[loop]+global_textentry_width[loop]){
               if(global_event.xbutton.y >= global_textentry_y[loop]){
                 if(global_event.xbutton.y <=  global_textentry_y[loop]+16){

                   //set all non focused
                   for(loop2=0;loop2<global_textentry_num;loop2++){
                     gdx_textentry_obj.focus[loop2]=0;
                     for(loop3=1;loop3<14;loop3++){
                       XDrawLine(display,window2,global_pen2,global_textentry_x[loop2]+1,global_textentry_y[loop2]+loop3,
                       global_textentry_x[loop2]+global_textentry_width[loop2],global_textentry_y[loop2]+loop3);
                     }
                     if(global_textentry_type[loop2]==0){
                       XDrawString(display,window2,global_pen,global_textentry_x[loop2]+6,global_textentry_y[loop2]+12,numberstring[loop2],strlen(numberstring[loop2]));
                     }
                     if(global_textentry_type[loop2]==1){
                       XDrawString(display,window2,global_pen,global_textentry_x[loop2]+6,global_textentry_y[loop2]+12,"****************",place[loop2]/6);
                     }

                   }
                   gdx_textentry_obj.focus[loop]=1;
                   for(loop3=1;loop3<14;loop3++){
                      XDrawLine(display,window2,global_pen4,global_textentry_x[loop]+1,global_textentry_y[loop]+loop3,
                      global_textentry_x[loop]+global_textentry_width[loop],global_textentry_y[loop]+loop3);
                   }

                   if(global_textentry_type[loop]==0){
                     XDrawString(display,window2,global_pen,global_textentry_x[loop]+6,global_textentry_y[loop]+12,numberstring[loop],strlen(numberstring[loop]));
                   }

                   if(global_textentry_type[loop]==1){
                     XDrawString(display,window2,global_pen,global_textentry_x[loop]+6,global_textentry_y[loop]+12,"****************",place[loop]/6);
                   }

                 }
               }
             }
           }
        }

        //find for all buttons- if clicked exec callback
        for(loop=0;loop<global_button_num;loop++){
           if(global_event.xbutton.x >= global_button_x[loop]-3){
             if(global_event.xbutton.x <= global_button_x[loop]+(strlen(global_button_text[loop])*6)+2){
               if(global_event.xbutton.y >= global_button_y[loop]-12){
                 if(global_event.xbutton.y <=  global_button_y[loop]+2){
                   gdx_ExecCallback(loop);
                 }
               }
             }
           }
        }

        //find for all menuitems- if clicked exec callback
        for(loop=0;loop<global_menuitem_num;loop++){
           if(global_event.xbutton.x >= global_menuitem_x[loop]-3 && global_event.xbutton.window == pulldown[global_menuitem_parent[loop]]){
             if(global_event.xbutton.x <= global_menuitem_x[loop]+(strlen(global_menuitem_label[loop])*6)+2){
               if(global_event.xbutton.y >= global_menuitem_y[loop]-7){
                 if(global_event.xbutton.y <=  global_menuitem_y[loop]+2){
                   gdx_ExecCallback3(loop);
                 }
               }
             }
           }
        }

        //image button
        for(loop=0;loop<global_imagebutton_num;loop++){
           if(global_event.xbutton.window == xpm_imagebutton[loop]){
                   gdx_ExecCallback4(loop);
           }
        }


        //find for all 'light buttons' - if clicked exec callback
        for(loop=0;loop<global_lbutton_num;loop++){
           if(global_event.xbutton.x >= global_lbutton_x[loop]-3){
             if(global_event.xbutton.x <= global_lbutton_x[loop]+(strlen(global_lbutton_text[loop])*6)+2){
               if(global_event.xbutton.y >= global_lbutton_y[loop]-12){
                 if(global_event.xbutton.y <=  global_lbutton_y[loop]+2){

                   if(gdx_lbutton_obj.selected[loop]==1) gdx_lbutton_obj.selected[loop]=0;
                   else gdx_lbutton_obj.selected[loop]=1;

                   if(gdx_lbutton_obj.selected[loop]==1)XFillRectangle(display, window2, gcpixmap1, global_lbutton_x[loop]-1,global_lbutton_y[loop]-9,10,10);
                   else XFillRectangle(display, window2, gcpixmap2, global_lbutton_x[loop]-1,global_lbutton_y[loop]-9,10,10); 

                   //light frame
                   XDrawLine(display,window2,global_pen3, global_lbutton_x[loop]-2, global_lbutton_y[loop],
                              global_lbutton_x[loop]-2, global_lbutton_y[loop]-9);
                   XDrawLine(display,window2,global_pen3, global_lbutton_x[loop]-2, global_lbutton_y[loop]-10,
                              global_lbutton_x[loop]+8, global_lbutton_y[loop]-10);
                   XDrawLine(display,window2,global_pen2, global_lbutton_x[loop]+9, global_lbutton_y[loop]-10,
                              global_lbutton_x[loop]+9, global_lbutton_y[loop]);
                   XDrawLine(display,window2,global_pen2, global_lbutton_x[loop]+9, global_lbutton_y[loop],
                              global_lbutton_x[loop]-1, global_lbutton_y[loop]);
                   gdx_ExecCallback2(loop);
                 }
               }
             }
           }
        }



        //find for all check buttons
        for(loop=0;loop<global_chkbutton_num;loop++){
           if(global_event.xbutton.x >= global_chkbutton_x[loop]){
             if(global_event.xbutton.x <= global_chkbutton_x[loop]+13){
               if(global_event.xbutton.y >= global_chkbutton_y[loop]){
                 if(global_event.xbutton.y <=  global_chkbutton_y[loop]+13){
                   for(loop2=2;loop2<12;loop2++){
                      XDrawLine(display,window2,global_pen2,global_chkbutton_x[loop]+2,global_chkbutton_y[loop]+loop2,
                                                            global_chkbutton_x[loop]+11,global_chkbutton_y[loop]+loop2);
                       }
                   if(gdx_chkbutton_obj.selected[loop]==1)gdx_chkbutton_obj.selected[loop]=0;
                   else{
                      gdx_chkbutton_obj.selected[loop]=1;
                      XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+3, global_chkbutton_y[loop]+5,
                                                            global_chkbutton_x[loop]+6, global_chkbutton_y[loop]+10);
                      XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+4, global_chkbutton_y[loop]+5,
                                                            global_chkbutton_x[loop]+7, global_chkbutton_y[loop]+10);
                      XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+6, global_chkbutton_y[loop]+10,
                                                            global_chkbutton_x[loop]+10, global_chkbutton_y[loop]+2);
                      XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+7, global_chkbutton_y[loop]+10,
                                                            global_chkbutton_x[loop]+11, global_chkbutton_y[loop]+2);

                   }
                 }
               }
             }
           }
        }

        //find for all selectlists
        for(loop=0;loop<global_selectlist_num;loop++){
           //if down arrow
           if(global_event.xbutton.x >=global_selectlist_x[loop]+global_selectlist_c[loop]+1){
             if(global_event.xbutton.x <=global_selectlist_x[loop]+global_selectlist_c[loop]+11){
               if(global_event.xbutton.y >= global_selectlist_y[loop]+ global_selectlist_r[loop]-10){
                 if(global_event.xbutton.y <= global_selectlist_y[loop]+ global_selectlist_r[loop]){
                   if(gdx_selectlist_obj.position[loop] != (global_selectlist_nl[loop]-global_selectlist_r[loop]/10))gdx_selectlist_obj.hilitepos[loop]=gdx_selectlist_obj.hilitepos[loop] - 10;
                   gdx_selectlist_obj.position[loop]++;
                   if(gdx_selectlist_obj.position[loop] >= global_selectlist_nl[loop]-global_selectlist_r[loop]/10){
                       gdx_selectlist_obj.position[loop]=global_selectlist_nl[loop]-global_selectlist_r[loop]/10;
                   }
                   for(loop2=0;loop2<   global_selectlist_r[loop];loop2++){
                     XDrawLine(display,window2,global_pen2,global_selectlist_x[loop],   global_selectlist_y[loop]+loop2,
                                                      global_selectlist_x[loop]+global_selectlist_c[loop],global_selectlist_y[loop]+loop2);
                   }
                   for(loop2=0;loop2<global_selectlist_r[loop]/10;loop2++){
                     XDrawString(display,window2,global_pen, global_selectlist_x[loop]+2, global_selectlist_y[loop]+(loop2*10)+9,
                                 gdx_selectlist_obj.item[loop2+gdx_selectlist_obj.position[loop]][loop],
                                 strlen(gdx_selectlist_obj.item[loop2+gdx_selectlist_obj.position[loop]][loop]) );
                   }
                 }
               }
             }
           }
           //if up arrow
           if(global_event.xbutton.x >=global_selectlist_x[loop]+global_selectlist_c[loop]+1){
             if(global_event.xbutton.x <=global_selectlist_x[loop]+global_selectlist_c[loop]+11){
               if(global_event.xbutton.y >= global_selectlist_y[loop]){
                 if(global_event.xbutton.y <= global_selectlist_y[loop]+10){
                   if(gdx_selectlist_obj.position[loop] != 0) gdx_selectlist_obj.hilitepos[loop] = gdx_selectlist_obj.hilitepos[loop] + 10;
                   gdx_selectlist_obj.position[loop]--;
                   if(gdx_selectlist_obj.position[loop] <= 0){
                       gdx_selectlist_obj.position[loop]=0;
                   }
                   for(loop2=0;loop2<  global_selectlist_r[loop];loop2++){
                     XDrawLine(display,window2,global_pen2,global_selectlist_x[loop],   global_selectlist_y[loop]+loop2,
                                                      global_selectlist_x[loop]+global_selectlist_c[loop],global_selectlist_y[loop]+loop2);
                   }
                   for(loop2=0;loop2< global_selectlist_r[loop]/10;loop2++){
                     XDrawString(display,window2,global_pen, global_selectlist_x[loop]+2, global_selectlist_y[loop]+(loop2*10)+9,
                                 gdx_selectlist_obj.item[loop2+gdx_selectlist_obj.position[loop]][loop],
                                 strlen(gdx_selectlist_obj.item[loop2+gdx_selectlist_obj.position[loop]][loop]) );
                   }
                 }
               }
             }
           }
           //if position(row) selected
           for(loop3=0;loop3<=global_selectlist_r[loop];loop3=loop3+10){
           //if postion 1
           if(global_event.xbutton.x >=global_selectlist_x[loop]){
             if(global_event.xbutton.x <=global_selectlist_x[loop]+global_selectlist_c[loop]){
               if(global_event.xbutton.y >= global_selectlist_y[loop]+loop3+1){
                 if(global_event.xbutton.y <= global_selectlist_y[loop]+loop3+10){
                   gdx_selectlist_obj.selected[loop]= loop3/10 + gdx_selectlist_obj.position[loop];
                   gdx_selectlist_obj.hilitepos[loop]=loop3;
                 }
               }
             }
           }
           }
          //change display
          XDrawLine(display,window2,global_pen2,global_selectlist_x[loop]-1, global_selectlist_y[loop]+  global_selectlist_r[loop],
                                                global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]+  global_selectlist_r[loop]);
          //refresh for all for white back ground
          for(loop2=0;loop2< global_selectlist_r[loop];loop2++){
             XDrawLine(display,window2,global_pen2,global_selectlist_x[loop],   global_selectlist_y[loop]+loop2,
                                       global_selectlist_x[loop]+global_selectlist_c[loop],global_selectlist_y[loop]+loop2);
          }
          //if another widget is clicked then refresh hilight if item had been selected.
          for(loop2=0;loop2<10;loop2++){
            if(gdx_selectlist_obj.selected[loop]!=-1){
               if(gdx_selectlist_obj.hilitepos[loop] >= 0 && gdx_selectlist_obj.hilitepos[loop] <= global_selectlist_r[loop]-10){
                 XDrawLine(display,window2,global_pen4, global_selectlist_x[loop],
                                       global_selectlist_y[loop]+loop2+gdx_selectlist_obj.hilitepos[loop],
                                       global_selectlist_x[loop]+global_selectlist_c[loop],
                                       global_selectlist_y[loop]+loop2+gdx_selectlist_obj.hilitepos[loop]);
               }
             }
          }

          for(loop2=0;loop2<global_selectlist_r[loop]/10;loop2++){
             XDrawString(display,window2,global_pen, global_selectlist_x[loop]+2, global_selectlist_y[loop]+(loop2*10)+9,
                         gdx_selectlist_obj.item[loop2+gdx_selectlist_obj.position[loop]][loop],
                         strlen(gdx_selectlist_obj.item[loop2+gdx_selectlist_obj.position[loop]][loop]) );
          }
       

        } //end selectlist



      }

      if (global_event.type == Expose){ // && global_event.xexpose.count == 0) {
            XWindowAttributes xwa;       // Temp Get Window Attribute struct
            while (XCheckTypedEvent(display, Expose, &global_event));
            if (XGetWindowAttributes(display, window2, &xwa) == 0) break;

            XClearWindow(display, window2);

            //background
            if(background_pixmap==1){
                           XFlush(display);
                           if (windowtile==0)XFillRectangle(display, window2, gcP, 0, 0,attributes_bg.width ,attributes_bg.height );
                           if (windowtile==1)XFillRectangle(display, window2, gcP, 0, 0,1024,860);
            }




            //menubar
            if(global_menubar_num == 1 || global_menubar_num == 2){
              for(loop2=0;loop2<18;loop2++){
                //XDrawLine(display, window2,global_pen5, 0 , loop2, 1111, loop2); 
                XDrawLine(display,window2,gcP_menu,0 , loop2, 1111, loop2);
              }
              //XDrawLine(display, window2, global_pen3, 0 , loop2+1, 1111, loop2+1);
              XDrawLine(display, window2, global_pen, 0, loop2+1, 1111, loop2+1);  
            }
            if(global_menubar_num == 2){
              for(loop2=20;loop2<38;loop2++){
                XDrawLine(display, window2,global_pen5, 0 , loop2, 1111, loop2);
              }
              XDrawLine(display, window2, global_pen3, 0 , loop2+1, 1111, loop2+1);
            }


            //menus
            for(loop=0;loop<global_menu_num;loop++){
              XDrawLine(display,pulldown[loop],global_pen2,0,0,100,0);
              XDrawLine(display,pulldown[loop],global_pen2,0,0,0,900);
              XDrawLine(display,pulldown[loop],global_pen3,99,0,99,900);
              for(loop2=0;loop2<20;loop2++){
               if(global_menu_parent[loop]==loop2)
                 XDrawString(display,window2,global_pen, global_menu_x[loop],12, global_menu_label[loop],strlen(global_menu_label[loop]));
              }
            }

            //menusitem
            for(loop=0;loop<global_menuitem_num;loop++){
             for(loop2=0;loop2<20;loop2++){
               if(global_menuitem_parent[loop]==loop2)
                   XDrawString(display,pulldown[loop2],global_pen, global_menuitem_x[loop],global_menuitem_y[loop], 
                               global_menuitem_label[loop],strlen(global_menuitem_label[loop]));
              }
            }



            //pie
            for(loop=0;loop<global_pie_num;loop++){
              XFillArc (display,window2,global_pen3,global_pie_x[loop],global_pie_y[loop],global_pie_r[loop],global_pie_r[loop],0,360*64);
              XFillArc(display,window2,global_pen2,global_pie_x[loop],global_pie_y[loop],global_pie_r[loop],global_pie_r[loop],0,gdx_pie_obj.perc[loop]*3.6*64);
              //outter ring
              XDrawArc (display,window2,global_pen,global_pie_x[loop],global_pie_y[loop],global_pie_r[loop],global_pie_r[loop],0,360*64);
              sprintf(pietext,"%d%%",gdx_pie_obj.perc[loop]);
              XDrawString(display,window2,global_pen,
                                     global_pie_x[loop]+global_pie_r[loop]-20,
                                     global_pie_y[loop]+(global_pie_r[loop]/2)-1,pietext,strlen(pietext));
            }


            //label
            for(loop=0;loop<global_label_num;loop++){
              XMapWindow(display,wlabel[loop]);

 
              //label background
              if(backgroundlabel_pixmap[loop]==1){
                           XFlush(display);
                           if (labeltile[loop]==0)XFillRectangle(display, wlabel[loop], gcP_label[loop], 0, 0,attributes_bg.width ,attributes_bg.height );
                           if (labeltile[loop]==1)XFillRectangle(display, wlabel[loop], gcP_label[loop], 0, 0,640,20);
              }
 

              if(global_label_border[loop]==1 || global_label_border[loop]==3){
                //bottom line
                XDrawLine(display,wlabel[loop],global_pen,0,12,strlen(global_label_text[loop])*6+4, 12); 
              }
              if(global_label_border[loop]==2){
                //bottom line
                XDrawLine(display,wlabel[loop],global_pen2,0,12,strlen(global_label_text[loop])*6+4, 12);
              }
              if(global_label_border[loop]==1 || global_label_border[loop]==2){
                //top line
                XDrawLine(display,wlabel[loop],global_pen,0,0,strlen(global_label_text[loop])*6+4,0);
              }
              if(global_label_border[loop]==3){
                //top line
                XDrawLine(display,wlabel[loop],global_pen2,0,0,strlen(global_label_text[loop])*6+4,0);
              }
              if(global_label_border[loop]==1 || global_label_border[loop]==2){
                //left line
                XDrawLine(display,wlabel[loop],global_pen, 0, 0, 0, 11);
              }
              if(global_label_border[loop]==3){
                //left line
                XDrawLine(display,wlabel[loop],global_pen2, 0, 0, 0, 11);
              }
              if(global_label_border[loop]==1 || global_label_border[loop]==3){
                //right line
                XDrawLine(display,wlabel[loop],global_pen, (strlen(global_label_text[loop])*6)+4, 0,(strlen(global_label_text[loop])*6)+4, 11);
              }
              if(global_label_border[loop]==2){
                //right line
                XDrawLine(display,wlabel[loop],global_pen2, (strlen(global_label_text[loop])*6)+4, 0,(strlen(global_label_text[loop])*6)+4, 11);
              }
              XDrawString(display, wlabel[loop], global_pen, 3 , 11, global_label_text[loop], strlen(global_label_text[loop]));
            }//end label

            //h-line
            for(loop=0;loop<global_hline_num;loop++){
              XDrawLine(display,window2,global_pen,
                        global_hline_x[loop],global_hline_y[loop],
                        global_hline_x[loop]+global_hline_len[loop],global_hline_y[loop]);
              XDrawLine(display,window2,global_pen2,
                        global_hline_x[loop],global_hline_y[loop]+1,
                        global_hline_x[loop]+global_hline_len[loop],global_hline_y[loop]+1);
            }//end hline

            //v-line
            for(loop=0;loop<global_vline_num;loop++){
              XDrawLine(display,window2,global_pen,
                        global_vline_x[loop],global_vline_y[loop],
                        global_vline_x[loop],global_vline_y[loop]+global_vline_len[loop]);
              XDrawLine(display,window2,global_pen2,
                        global_vline_x[loop]+1,global_vline_y[loop],
                        global_vline_x[loop]+1,global_vline_y[loop]+global_vline_len[loop]);
            }//end vline


            // push buttons
            for(loop=0;loop<global_button_num;loop++){



              //background
              for(loop2=0;loop2<16;loop2++){
                XDrawLine(display,window2,global_button_pen[loop],global_button_x[loop]-4, global_button_y[loop]-13+loop2,
                          global_button_x[loop]+(strlen(global_button_text[loop])*6)+3, global_button_y[loop]-13+loop2);
              }

              //text 
              XDrawString(display, window2, global_pen, global_button_x[loop], global_button_y[loop], global_button_text[loop], strlen(global_button_text[loop]));

              //bottom line
              XDrawLine(display,window2,global_pen3, global_button_x[loop]-4, global_button_y[loop]+3,
                        global_button_x[loop]+(strlen(global_button_text[loop])*6)+3, global_button_y[loop]+3);
              XDrawLine(display,window2,global_pen, global_button_x[loop]-5, global_button_y[loop]+4,
                        global_button_x[loop]+(strlen(global_button_text[loop])*6)+4, global_button_y[loop]+4);

              //left line
              XDrawLine(display,window2,global_pen2, global_button_x[loop]-4, global_button_y[loop]+3,
                        global_button_x[loop]-4, global_button_y[loop]-13);
              XDrawLine(display,window2,global_pen , global_button_x[loop]-5, global_button_y[loop]+4,
                        global_button_x[loop]-5, global_button_y[loop]-14);

              //right line
              XDrawLine(display,window2,global_pen3, global_button_x[loop]+(strlen(global_button_text[loop])*6)+3, global_button_y[loop]+3,
                        global_button_x[loop]+(strlen(global_button_text[loop])*6)+3, global_button_y[loop]-13);
              XDrawLine(display,window2,global_pen, global_button_x[loop]+(strlen(global_button_text[loop])*6)+4, global_button_y[loop]+4,
                        global_button_x[loop]+(strlen(global_button_text[loop])*6)+4, global_button_y[loop]-14);

              //top line
              XDrawLine(display,window2,global_pen2, global_button_x[loop]-4, global_button_y[loop]-13,
                        global_button_x[loop]+(strlen(global_button_text[loop])*6)+3, global_button_y[loop]-13);
              XDrawLine(display,window2,global_pen , global_button_x[loop]-5, global_button_y[loop]-14,
                        global_button_x[loop]+(strlen(global_button_text[loop])*6)+4, global_button_y[loop]-14);


            }//end button 




            // image 
            for(loop=0;loop<global_image_num;loop++){
              XMapWindow(display, xpm_image[loop]);
              XFillRectangle(display, xpm_image[loop], global_image_i[loop], 0 , 0 ,global_image_w[loop],global_image_h[loop]);
            }  

            // image button
            for(loop=0;loop<global_imagebutton_num;loop++){
              XMapWindow(display, xpm_imagebutton[loop]);
              XFillRectangle(display, xpm_imagebutton[loop], global_imagebutton_i[loop], 0 , 0 ,global_imagebutton_w[loop],global_imagebutton_h[loop]);
              XDrawLine(display,xpm_imagebutton[loop],global_pen2,0,0,global_imagebutton_w[loop],0);
              XDrawLine(display,xpm_imagebutton[loop],global_pen2,0,0,0,global_imagebutton_h[loop]);
              XDrawLine(display,xpm_imagebutton[loop],global_pen,1,global_imagebutton_h[loop]-1,global_imagebutton_w[loop]-1,global_imagebutton_h[loop]-1);
              XDrawLine(display,xpm_imagebutton[loop],global_pen,global_imagebutton_w[loop]-1,1,global_imagebutton_w[loop]-1,global_imagebutton_h[loop]-1);
            }




            // push light buttons
            for(loop=0;loop<global_lbutton_num;loop++){
              if(gdx_lbutton_obj.selected[loop]==1)XFillRectangle(display, window2, gcpixmap1, global_lbutton_x[loop]-1,global_lbutton_y[loop]-9,10,10);
              else XFillRectangle(display, window2, gcpixmap2, global_lbutton_x[loop]-1,global_lbutton_y[loop]-9,10,10);

              //light frame
              XDrawLine(display,window2,global_pen3, global_lbutton_x[loop]-2, global_lbutton_y[loop],
                         global_lbutton_x[loop]-2, global_lbutton_y[loop]-9);
 
              XDrawLine(display,window2,global_pen3, global_lbutton_x[loop]-2, global_lbutton_y[loop]-10,
                         global_lbutton_x[loop]+8, global_lbutton_y[loop]-10);
 
              XDrawLine(display,window2,global_pen2, global_lbutton_x[loop]+9, global_lbutton_y[loop]-10,
                         global_lbutton_x[loop]+9, global_lbutton_y[loop]);
 
              XDrawLine(display,window2,global_pen2, global_lbutton_x[loop]+9, global_lbutton_y[loop],
                         global_lbutton_x[loop]-1, global_lbutton_y[loop]);

              //Text
              XDrawString(display, window2, global_pen, global_lbutton_x[loop]+12,global_lbutton_y[loop],global_lbutton_text[loop],strlen(global_lbutton_text[loop]));

              //bottom line
              XDrawLine(display,window2,global_pen3, global_lbutton_x[loop]-4, global_lbutton_y[loop]+3,
                        global_lbutton_x[loop]+(strlen(global_lbutton_text[loop])*6)+15, global_lbutton_y[loop]+3);
              XDrawLine(display,window2,global_pen , global_lbutton_x[loop]-5, global_lbutton_y[loop]+4,
                        global_lbutton_x[loop]+(strlen(global_lbutton_text[loop])*6)+16, global_lbutton_y[loop]+4);

              //left line
              XDrawLine(display,window2,global_pen2, global_lbutton_x[loop]-4, global_lbutton_y[loop]+3,
                        global_lbutton_x[loop]-4, global_lbutton_y[loop]-13);
              XDrawLine(display,window2,global_pen , global_lbutton_x[loop]-5, global_lbutton_y[loop]+4,
                        global_lbutton_x[loop]-5, global_lbutton_y[loop]-14);

              //right line
              XDrawLine(display,window2,global_pen3, global_lbutton_x[loop]+(strlen(global_lbutton_text[loop])*6)+15, global_lbutton_y[loop]+3,
                        global_lbutton_x[loop]+(strlen(global_lbutton_text[loop])*6)+15, global_lbutton_y[loop]-13);
              XDrawLine(display,window2,global_pen , global_lbutton_x[loop]+(strlen(global_lbutton_text[loop])*6)+16, global_lbutton_y[loop]+4,
                        global_lbutton_x[loop]+(strlen(global_lbutton_text[loop])*6)+16, global_lbutton_y[loop]-14);

              //top line
              XDrawLine(display,window2,global_pen2, global_lbutton_x[loop]-4, global_lbutton_y[loop]-13,
                        global_lbutton_x[loop]+(strlen(global_lbutton_text[loop])*6)+15, global_lbutton_y[loop]-13);
              XDrawLine(display,window2,global_pen , global_lbutton_x[loop]-5, global_lbutton_y[loop]-14,
                        global_lbutton_x[loop]+(strlen(global_lbutton_text[loop])*6)+16, global_lbutton_y[loop]-14);

            }//end button 





           // text entry 
            for(loop=0;loop<global_textentry_num;loop++){
              for(loop2=0;loop2<15;loop2++){
                XDrawLine(display,window2,global_pen2,global_textentry_x[loop],global_textentry_y[loop]+loop2,
                                                      global_textentry_x[loop]+global_textentry_width[loop],global_textentry_y[loop]+loop2);
              }
              XDrawLine(display,window2,global_pen3,global_textentry_x[loop],global_textentry_y[loop]-1,
                                                      global_textentry_x[loop]+global_textentry_width[loop]+1,global_textentry_y[loop]-1);

              XDrawLine(display,window2,global_pen,global_textentry_x[loop],global_textentry_y[loop],
                                                      global_textentry_x[loop]+global_textentry_width[loop],global_textentry_y[loop]);

              XDrawLine(display,window2,global_pen,global_textentry_x[loop],global_textentry_y[loop],
                                                      global_textentry_x[loop],global_textentry_y[loop]+15);

              XDrawLine(display,window2,global_pen2,global_textentry_x[loop]+global_textentry_width[loop]+2,global_textentry_y[loop]-1,
                                                      global_textentry_x[loop]+global_textentry_width[loop]+2,global_textentry_y[loop]+16);

              XDrawLine(display,window2,global_pen2,global_textentry_x[loop],global_textentry_y[loop]+16,
                                                    global_textentry_x[loop]+global_textentry_width[loop]+2,global_textentry_y[loop]+16);

              XDrawString(display, window2, global_pen, global_textentry_x[loop]+6,global_textentry_y[loop]+12, numberstring[loop], strlen(numberstring[loop]));
            }//end text entry 




           // check buttons
            for(loop=0;loop<global_chkbutton_num;loop++){
              XDrawString(display,window2,global_pen,global_chkbutton_x[loop]+17,global_chkbutton_y[loop]+12,
                          global_chkbutton_label[loop],strlen(global_chkbutton_label[loop]));
              //top top
              XDrawLine(display,window2,global_pen3,global_chkbutton_x[loop],   global_chkbutton_y[loop],   global_chkbutton_x[loop]+12,global_chkbutton_y[loop]);
              //mid top
              XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+1, global_chkbutton_y[loop]+1, global_chkbutton_x[loop]+11,global_chkbutton_y[loop]+1);
              //top right
              XDrawLine(display,window2,global_pen2,global_chkbutton_x[loop]+13,global_chkbutton_y[loop],   global_chkbutton_x[loop]+13,global_chkbutton_y[loop]+13);
              //top bottom
              XDrawLine(display,window2,global_pen2,global_chkbutton_x[loop],   global_chkbutton_y[loop]+13,global_chkbutton_x[loop]+13,global_chkbutton_y[loop]+13);
              //top left
              XDrawLine(display,window2,global_pen3,global_chkbutton_x[loop],   global_chkbutton_y[loop],   global_chkbutton_x[loop],   global_chkbutton_y[loop]+12);
              //mid left
              XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+1, global_chkbutton_y[loop]+1, global_chkbutton_x[loop]+1, global_chkbutton_y[loop]+11);
              //mid mid
              for(loop2=2;loop2<12;loop2++){
                XDrawLine(display,window2,global_pen2,global_chkbutton_x[loop]+2,global_chkbutton_y[loop]+loop2,global_chkbutton_x[loop]+11,global_chkbutton_y[loop]+loop2); 
              }
              if(gdx_chkbutton_obj.selected[loop]==1){
                XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+3, global_chkbutton_y[loop]+5, global_chkbutton_x[loop]+6, global_chkbutton_y[loop]+10);
                XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+4, global_chkbutton_y[loop]+5, global_chkbutton_x[loop]+7, global_chkbutton_y[loop]+10);
                XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+6, global_chkbutton_y[loop]+10, global_chkbutton_x[loop]+10, global_chkbutton_y[loop]+2);
                XDrawLine(display,window2,global_pen, global_chkbutton_x[loop]+7, global_chkbutton_y[loop]+10, global_chkbutton_x[loop]+11, global_chkbutton_y[loop]+2);
              }

            }//end button 



            for(loop=0;loop<global_selectlist_num;loop++){
              //text area
              for(loop2=0;loop2< global_selectlist_r[loop];loop2++){
                XDrawLine(display,window2,global_pen2,global_selectlist_x[loop],   global_selectlist_y[loop]+loop2,
                                                      global_selectlist_x[loop]+global_selectlist_c[loop],global_selectlist_y[loop]+loop2);
              }
              XDrawLine(display,window2,global_pen ,global_selectlist_x[loop]-1, global_selectlist_y[loop]-1,
                                                    global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]-1);              
              XDrawLine(display,window2,global_pen2,global_selectlist_x[loop]-1, global_selectlist_y[loop]+ global_selectlist_r[loop],
                                                    global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]+ global_selectlist_r[loop]);
              XDrawLine(display,window2,global_pen, global_selectlist_x[loop]-1, global_selectlist_y[loop]-1,
                                                    global_selectlist_x[loop]-1, global_selectlist_y[loop]+ global_selectlist_r[loop]-1);
              //button up
              XDrawLine(display,window2,global_pen2,global_selectlist_x[loop]+global_selectlist_c[loop]+1, global_selectlist_y[loop],
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]);
              XDrawLine(display,window2,global_pen,global_selectlist_x[loop]+global_selectlist_c[loop]+1, global_selectlist_y[loop]+10,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]+10);
              XDrawLine(display,window2,global_pen2,global_selectlist_x[loop]+global_selectlist_c[loop]+1, global_selectlist_y[loop]+11,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]+11);
              //button up arrow
              XDrawLine(display,window2,global_pen,global_selectlist_x[loop]+global_selectlist_c[loop]+5, global_selectlist_y[loop]+4,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+6,global_selectlist_y[loop]+4);
              XDrawLine(display,window2,global_pen,global_selectlist_x[loop]+global_selectlist_c[loop]+4, global_selectlist_y[loop]+5,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+7,global_selectlist_y[loop]+5);
              XDrawLine(display,window2,global_pen,global_selectlist_x[loop]+global_selectlist_c[loop]+3, global_selectlist_y[loop]+6,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+8,global_selectlist_y[loop]+6);

              //button down
              XDrawLine(display,window2,global_pen ,global_selectlist_x[loop]+global_selectlist_c[loop]+1, global_selectlist_y[loop]+ global_selectlist_r[loop]-12,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]+ global_selectlist_r[loop]-12);
              XDrawLine(display,window2,global_pen2,global_selectlist_x[loop]+global_selectlist_c[loop]+1, global_selectlist_y[loop]+ global_selectlist_r[loop]-11,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]+ global_selectlist_r[loop]-11);
              XDrawLine(display,window2,global_pen,global_selectlist_x[loop]+global_selectlist_c[loop]+1, global_selectlist_y[loop]+ global_selectlist_r[loop]-1,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]+ global_selectlist_r[loop]-1);
              //button down arrow
              XDrawLine(display,window2,global_pen,global_selectlist_x[loop]+global_selectlist_c[loop]+5, global_selectlist_y[loop]+ global_selectlist_r[loop]-5,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+6,global_selectlist_y[loop]+ global_selectlist_r[loop]-5);
              XDrawLine(display,window2,global_pen,global_selectlist_x[loop]+global_selectlist_c[loop]+4, global_selectlist_y[loop]+ global_selectlist_r[loop]-6,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+7,global_selectlist_y[loop]+ global_selectlist_r[loop]-6);
              XDrawLine(display,window2,global_pen,global_selectlist_x[loop]+global_selectlist_c[loop]+3, global_selectlist_y[loop]+ global_selectlist_r[loop]-7,
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+8,global_selectlist_y[loop]+ global_selectlist_r[loop]-7);


              //right side
              XDrawLine(display,window2,global_pen,global_selectlist_x[loop]+global_selectlist_c[loop]+11, global_selectlist_y[loop],
                                                   global_selectlist_x[loop]+global_selectlist_c[loop]+11,global_selectlist_y[loop]+ global_selectlist_r[loop]-1);



           //if another widget is clicked refresh hilight if item had been selected.
           for(loop2=0;loop2<10;loop2++){
             if(gdx_selectlist_obj.selected[loop]!=-1){
                if(gdx_selectlist_obj.hilitepos[loop] >= 0 && gdx_selectlist_obj.hilitepos[loop] <= 40)
                                        XDrawLine(display,window2,global_pen4, global_selectlist_x[loop],
                                        global_selectlist_y[loop]+loop2+gdx_selectlist_obj.hilitepos[loop],
                                        global_selectlist_x[loop]+global_selectlist_c[loop],
                                        global_selectlist_y[loop]+loop2+gdx_selectlist_obj.hilitepos[loop]);

              }
           }


              for(loop2=0;loop2<global_selectlist_r[loop]/10;loop2++){
                XDrawString(display,window2,global_pen, global_selectlist_x[loop]+2, global_selectlist_y[loop]+(loop2*10)+9,
                            gdx_selectlist_obj.item[loop2+gdx_selectlist_obj.position[loop]][loop], 
                            strlen(gdx_selectlist_obj.item[loop2+gdx_selectlist_obj.position[loop]][loop]) );
              }

            }//end selectlist 

            //frame
            for(loop=0;loop<global_frame_num;loop++){
              XDrawString(display, window2, global_pen, global_frame_x1[loop] , global_frame_y1[loop], global_frame_label[loop], strlen(global_frame_label[loop]));
              //top
              XDrawLine(display, window2, global_pen, global_frame_x1[loop], global_frame_y1[loop], global_frame_x2[loop],global_frame_y1[loop]);
              XDrawLine(display, window2, global_pen2, global_frame_x1[loop], global_frame_y1[loop]+1, global_frame_x2[loop],global_frame_y1[loop]+1);
              //botton
              XDrawLine(display, window2, global_pen, global_frame_x1[loop], global_frame_y2[loop], global_frame_x2[loop],global_frame_y2[loop]);
              //left
              XDrawLine(display, window2, global_pen, global_frame_x1[loop], global_frame_y1[loop], global_frame_x1[loop],global_frame_y2[loop]);
              XDrawLine(display, window2, global_pen2, global_frame_x1[loop]+1, global_frame_y1[loop]+1, global_frame_x1[loop]+1,global_frame_y2[loop]);
              //right
              XDrawLine(display, window2, global_pen, global_frame_x2[loop], global_frame_y1[loop], global_frame_x2[loop],global_frame_y2[loop]);
            }


        } //event expose
    }
}

///////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////
void gdx_window(char *title, int size_x, int size_y){


   XpmAttributes attributes_buttons;
   XpmColorSymbol xpmcolor[1];
   Pixmap mask;
   XGCValues   pixmap_prop;
   Pixmap      pixmap1,  pixmap2;

   int x; //loop variable

  //make color safe? Does not seam to work
  int amount_alloc;
  Visual *visual;
  int screen;
  int depth;
  Colormap cmap;
  XVisualInfo vTemplate;   //template of the visual we want
  XColor *color;

  int loop, loop2, linesplace;
  unsigned long fth;             // Font size parameters
  unsigned long   bd = X_DGREY;
  unsigned long   fg = X_BLACK;
  unsigned long   bg = X_GREY;
  unsigned long   bw = 1;

  XSizeHints  xsh;
  XFontStruct *fontstruct;       // Font descriptor -- all global_pens given same font

  if ((fontstruct = XLoadQueryFont(display, "fixed")) == NULL) {
      printf("Display doesn't know the font fixed\n");
      exit(1);
  }
  fth = fontstruct->max_bounds.ascent + fontstruct->max_bounds.descent;
  xsh.flags = (PPosition | PSize);

  xsh.height = size_y;
  xsh.width = size_x;

  xsh.x = (DisplayWidth(display, DefaultScreen(display)) - xsh.width) / 2;
  xsh.y = (DisplayHeight(display, DefaultScreen(display)) - xsh.height) / 2 + 50;
  global_pen_prop.font = fontstruct->fid;
  global_pen2_prop.font = fontstruct->fid;
  global_pen3_prop.font = fontstruct->fid;
  global_pen4_prop.font = fontstruct->fid;
  global_pen5_prop.font = fontstruct->fid;
  global_pen6_prop.font = fontstruct->fid;

  global_button_pen_prop.font = fontstruct->fid;


  //set drawing color

  //second try to make color safe
  screen = DefaultScreen(display);

//  visual = DefaultVisual(display,screen);


  depth  = DefaultDepth(display, screen);
  //printf("depth ='%d' screen='%d'\n",depth,screen);


  global_pen_prop.foreground = X_BLACK;
  global_pen_prop.background = X_GREY;
  global_pen2_prop.foreground = X_WHITE;
  global_pen2_prop.background = X_GREY;
  global_pen3_prop.foreground = X_DGREY;
  global_pen3_prop.background = X_GREY;
  global_pen4_prop.foreground = X_YELLOW;
  global_pen4_prop.background = X_GREY;
  global_pen5_prop.background = X_GREY;
  global_pen5_prop.foreground = X_GREY;
  global_pen6_prop.foreground = X_BLUE4;
  global_pen6_prop.background = X_GREY;

  //set all buttons to default background of X_Grey
  global_button_pen_prop.foreground = X_GREY;
  global_button_pen_prop.background = X_GREY;

  window2 = XCreateSimpleWindow(display,DefaultRootWindow(display),xsh.x,xsh.y,xsh.width,xsh.height,bw,bd,bg);

  XSetStandardProperties(display, window2, title, title, None, NULL, 0, &xsh);
  global_pen = XCreateGC(display, window2, (GCFont | GCForeground | GCBackground), &global_pen_prop);
  global_pen2 = XCreateGC(display, window2, (GCFont | GCForeground | GCBackground), &global_pen2_prop);
  global_pen3 = XCreateGC(display, window2, (GCFont | GCForeground | GCBackground), &global_pen3_prop);
  global_pen4 = XCreateGC(display, window2, (GCFont | GCForeground | GCBackground), &global_pen4_prop);
  global_pen5 = XCreateGC(display, window2, (GCFont | GCForeground | GCBackground), &global_pen5_prop);
  global_pen6 = XCreateGC(display, window2, (GCFont | GCForeground | GCBackground), &global_pen6_prop);

  for(x=0;x<640;x++){
    global_button_pen[x] = XCreateGC(display, window2, (GCFont | GCForeground | GCBackground), &global_button_pen_prop);
  }

  XSelectInput(display, window2, EVENT_MASK);

  XMapWindow(display, window2); //show window2

  gdx_window_status=1;  

  //button pixmaps

      attributes_buttons.valuemask = XpmColormap;
      attributes_buttons.x_hotspot = 0;
      attributes_buttons.y_hotspot = 0;
      attributes_buttons.depth = DefaultDepth(display, DefaultScreen(display));;
      attributes_buttons.colormap = DefaultColormap(display, DefaultScreen(display));

      pixmap_prop.function = GXcopy;
      pixmap_prop.plane_mask = AllPlanes;
      pixmap_prop.foreground = 0;

      gcpixmap1 = XCreateGC(display, window2, GCForeground|GCFunction|GCPlaneMask, &pixmap_prop);
      attributes_buttons.valuemask = XpmSize;
      XpmCreatePixmapFromData(display, window2, rn_xpm, &pixmap1, &mask, &attributes_buttons);
      XSetFillStyle(display, gcpixmap1, FillTiled);
      XSetTile(display, gcpixmap1, pixmap1);
      //XSetClipMask(display,gcpixmap1,mask);

      gcpixmap2 = XCreateGC(display, window2, GCForeground|GCFunction|GCPlaneMask, &pixmap_prop);
      attributes_buttons.valuemask = XpmSize;
      XpmCreatePixmapFromData(display, window2, rn2_xpm, &pixmap2, &mask, &attributes_buttons);
      XSetFillStyle(display, gcpixmap2, FillTiled);
      XSetTile(display, gcpixmap2, pixmap2);
      //XSetClipMask(display,gcpixmap2,mask);

}

///////////////////////////////////////////
//
///////////////////////////////////////////
int gdx_label(char *text, int x_location, int y_location, int border){

  int label_width,label_height;
  XSizeHints  xsh;


  strcpy(global_label_text [global_label_num],text);;

  global_label_x[global_label_num] = x_location;
  global_label_y[global_label_num] = y_location;
  global_label_border[global_label_num] = border;

  label_width = (strlen(text)*6) +4; 
  label_height = 13;

  wlabel[global_label_num] = XCreateSimpleWindow(display,window2,x_location-2,y_location-11,label_width+1,label_height,0,X_GREY,X_GREY);

  global_label_num++;

  return global_label_num - 1;


}

void gdx_hseparator(int x, int y, int len){

 global_hline_x[global_hline_num] = x;
 global_hline_y[global_hline_num] = y;
 global_hline_len[global_hline_num] = len;

 global_hline_num++;


}

void gdx_vseparator(int x, int y, int len){

 global_vline_x[global_vline_num] = x;
 global_vline_y[global_vline_num] = y;
 global_vline_len[global_vline_num] = len;

 global_vline_num++;  //id of line for drawing purpose

}

///////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////
int gdx_button(int x, int y, char *text, void (*callback)() ){

  strcpy(global_button_text [global_button_num],text);

  global_button_x[global_button_num] = x;
  global_button_y[global_button_num] = y;

  gdx_setfunction(global_button_num,callback);


  global_button_num++; //id of button for event and drawing purpose


    //returns the id of the check button 
  return global_button_num - 1;


}

///////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////
void gdx_setbuttoncolor(int button, unsigned long color){

  global_button_pen_prop.foreground = color;
  global_button_pen_prop.background = color;

  global_button_pen[button] = XCreateGC(display, window2, (GCForeground | GCBackground), &global_button_pen_prop); 

}

///////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////
int gdx_lbutton(int x, int y, char *text, void (*callback)() ){

  strcpy(global_lbutton_text [global_lbutton_num],text);

  global_lbutton_x[global_lbutton_num] = x;
  global_lbutton_y[global_lbutton_num] = y;

  gdx_setfunction2(global_lbutton_num,callback);

  gdx_lbutton_obj.selected[global_lbutton_num]=0;


  global_lbutton_num++;

  //returns the id of the check button 
  return global_lbutton_num - 1;

}


/////////////////////////////////////////////////////////////////
// gdx_selectlist
/////////////////////////////////////////////////////////////////
int gdx_selectlist(int x, int y, int numberoflines, char lines[640][640], int cols, int rows)
{

  int loop;

  //set columns
  global_selectlist_c[global_selectlist_num] = cols;
 
  //set rows
  global_selectlist_r[global_selectlist_num] = rows;

  //don't allow less than 8 columns
  if( global_selectlist_c[global_selectlist_num] <= 7)  global_selectlist_c[global_selectlist_num] = 8;

  //don't allow less than 5 rows
  if( global_selectlist_r[global_selectlist_num] <= 4)  global_selectlist_r[global_selectlist_num] = 5;

  //magnify width by 10
  global_selectlist_c[global_selectlist_num]= global_selectlist_c[global_selectlist_num] * 10;

  //magnify height by 10
  global_selectlist_r[global_selectlist_num]= global_selectlist_r[global_selectlist_num] * 10;

  //set x placement in window
  global_selectlist_x[global_selectlist_num] = x;

  //set y placement in window
  global_selectlist_y[global_selectlist_num] = y;

  //set number of lines the list should display
  global_selectlist_nl[global_selectlist_num] = numberoflines;

  //by default nothing selected (-1)
  gdx_selectlist_obj.selected[global_selectlist_num]=-1;

  //start at the top of the list
  gdx_selectlist_obj.position[global_selectlist_num]=0;

  //insert list into select list object
  for(loop=0; loop < numberoflines; loop++){
    strcpy(gdx_selectlist_obj.item[loop][global_selectlist_num],lines[loop]);
  }

  global_selectlist_num++;
  
  //returns the id of the selectlist
  return global_selectlist_num - 1;
}



/////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////

int gdx_chkbutton(int x, int y, char *label)
{

  int loop;

  strcpy(global_chkbutton_label[global_chkbutton_num],label);

  global_chkbutton_x[global_chkbutton_num] = x;
  global_chkbutton_y[global_chkbutton_num] = y;


  //by default nothing selected (0)
  gdx_chkbutton_obj.selected[global_chkbutton_num]=0;


  global_chkbutton_num++;

  //returns the id of the check button 
  return global_chkbutton_num - 1;
}


/////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////
int gdx_textentry(int x, int y, int width, int type)
{


  global_textentry_x[global_textentry_num] = x;
  global_textentry_y[global_textentry_num] = y;

  global_textentry_width[global_textentry_num] = width;

  global_textentry_type[global_textentry_num] = type;

  //calculate maximum entries (characters)allowed.
  global_textentry_me[global_textentry_num] = width - 12;

  global_textentry_num++;

  //returns the id of the textentry 
  return global_textentry_num - 1;
}


////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////
void gdx_frame(int x1, int y1, int x2, int y2, char *label){

  global_frame_x1[global_frame_num]=x1;
  global_frame_y1[global_frame_num]=y1;
  global_frame_x2[global_frame_num]=x2;
  global_frame_y2[global_frame_num]=y2;

  strcpy(global_frame_label[global_frame_num],label);

  global_frame_num++;

}

///////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////
void gdx_closewindow()
{

  XUnmapWindow(display,window2);

  gdx_window_status=0;

}


////////////////////////////////////////////////////
//
///////////////////////////////////////////////////
void gdx_settextentry (int id, char *string)
{

  GDX_event_flag=1;

  strcpy(gdx_textentry_obj.string[id],string);
  place[id]=strlen(string)*6;
  strcpy(numberstring[id],string);

}


/////////////////////////////////////////////////////
//
////////////////////////////////////////////////////
void gdx_setwindowbg(char *filename, int format)
{
     XGCValues PM_prop;
     Pixmap mask, pm, pmP;
     XpmColorSymbol xpmcolor[1];

     attributes_bg.valuemask = XpmColormap;
     attributes_bg.x_hotspot = 0;
     attributes_bg.y_hotspot = 0;
     attributes_bg.depth = DefaultDepth(display, DefaultScreen(display));;
     attributes_bg.colormap = DefaultColormap(display, DefaultScreen(display));

     PM_prop.function = GXcopy;
     PM_prop.plane_mask = AllPlanes;
     PM_prop.foreground = 0;

     gcP = XCreateGC(display, window2, GCForeground|GCFunction|GCPlaneMask, &PM_prop);

     attributes_bg.valuemask = XpmSize;

     XpmReadFileToPixmap(display,window2,filename,&pmP,&mask,&attributes_bg);

     XSetFillStyle(display, gcP, FillTiled);
     XSetTile(display, gcP, pmP);

     //if not tiled apply mask
     if(format==0){
        XSetClipMask(display,gcP,mask);
        windowtile=0;
     }
     else{
        windowtile=1;
     }

     imagew=attributes_bg.width;
     imageh=attributes_bg.height;

     //let the event manager know
     background_pixmap=1;

}

///////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////

int gdx_image(int x, int y, char *image){

  XGCValues PM_prop;
  Pixmap    mask, pixmap1;
  XpmAttributes attributes_i;

  attributes_i.valuemask = XpmColormap;
  attributes_i.x_hotspot = 0;
  attributes_i.y_hotspot = 0;
  attributes_i.depth = DefaultDepth(display, DefaultScreen(display));;
  attributes_i.colormap = DefaultColormap(display, DefaultScreen(display));

  PM_prop.function = GXcopy;
  PM_prop.plane_mask = AllPlanes;
  PM_prop.foreground = 0;

  global_image_i[global_image_num] = XCreateGC(display, window2, GCForeground|GCFunction|GCPlaneMask, &PM_prop);
  attributes_i.valuemask = XpmSize;
  XpmReadFileToPixmap(display,window2,image,&pixmap1,&mask,&attributes_i);
  XSetFillStyle(display, global_image_i[global_image_num], FillTiled);
  XSetTile(display, global_image_i[global_image_num], pixmap1);

  global_image_x[global_image_num]=x;
  global_image_y[global_image_num]=y;
  global_image_w[global_image_num]=attributes_i.width;
  global_image_h[global_image_num]=attributes_i.height;

  xpm_image[global_image_num] = XCreateSimpleWindow(display,window2,x,y,attributes_i.width,attributes_i.height,0,X_GREY,X_GREY);

  global_image_num++;

  return global_image_num - 1;
}

/////////////////////////
//
////////////////////////

void gdx_hlineroot(int byspace){

  int yyy;

  for(yyy=0;yyy<=2000;yyy+byspace){
    XDrawLine(display, window2, global_pen,0,yyy,2000,yyy);
  }


} 


/////////////////////////////////////
//
/////////////////////////////////////
void gdx_imageupdate(int image_num, char *image){


  XGCValues PM_prop;
  Pixmap    mask, pixmap1;
  XpmAttributes attributes_i;

  attributes_i.valuemask = XpmColormap;
  attributes_i.x_hotspot = 0;
  attributes_i.y_hotspot = 0;
  attributes_i.depth = DefaultDepth(display, DefaultScreen(display));;
  attributes_i.colormap = DefaultColormap(display, DefaultScreen(display));

  PM_prop.function = GXcopy;
  PM_prop.plane_mask = AllPlanes;
  PM_prop.foreground = 0;

  global_image_i[image_num] = XCreateGC(display, window2, GCForeground|GCFunction|GCPlaneMask, &PM_prop);
  attributes_i.valuemask = XpmSize;
  XpmReadFileToPixmap(display,window2,image,&pixmap1,&mask,&attributes_i);
  XSetFillStyle(display, global_image_i[image_num], FillTiled);
  XSetTile(display, global_image_i[image_num], pixmap1);

  global_image_w[image_num]=attributes_i.width;
  global_image_h[image_num]=attributes_i.height;

 XFillRectangle(display, xpm_image[image_num], global_image_i[image_num], 0 , 0 ,global_image_w[image_num],global_image_h[image_num]);


}
///////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////
  
int gdx_imagebutton(int x, int y, char *image, void (*callback)()){
  
  XGCValues PM_prop;
  Pixmap    mask, pixmap1;
  XpmAttributes attributes_i;

  attributes_i.valuemask = XpmColormap;
  attributes_i.x_hotspot = 0;
  attributes_i.y_hotspot = 0;
  attributes_i.depth = DefaultDepth(display, DefaultScreen(display));;
  attributes_i.colormap = DefaultColormap(display, DefaultScreen(display));

  PM_prop.function = GXcopy;
  PM_prop.plane_mask = AllPlanes;
  PM_prop.foreground = 0;

  global_imagebutton_i[global_imagebutton_num] = XCreateGC(display, window2, GCForeground|GCFunction|GCPlaneMask, &PM_prop);
  attributes_i.valuemask = XpmSize;
  XpmReadFileToPixmap(display,window2,image,&pixmap1,&mask,&attributes_i);
  XSetFillStyle(display, global_imagebutton_i[global_imagebutton_num], FillTiled);
  XSetTile(display, global_imagebutton_i[global_imagebutton_num], pixmap1);

  gdx_setfunction4(global_imagebutton_num,callback);

  global_imagebutton_x[global_imagebutton_num]=x;
  global_imagebutton_y[global_imagebutton_num]=y;
  global_imagebutton_w[global_imagebutton_num]=attributes_i.width;
  global_imagebutton_h[global_imagebutton_num]=attributes_i.height;

  xpm_imagebutton[global_imagebutton_num] = XCreateSimpleWindow(display,window2,x,y,attributes_i.width,attributes_i.height,0,X_GREY,X_GREY);

  XSelectInput(display, xpm_imagebutton[global_imagebutton_num], EVENT_MASK);

  global_imagebutton_num++;

  return global_imagebutton_num - 1;
}


////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////
int gdx_pie(int x, int y, int radius, int percent){

  int loop;

  global_pie_x[global_pie_num] = x;
  global_pie_y[global_pie_num] = y;
  global_pie_r[global_pie_num] = radius;

  gdx_pie_obj.perc[global_pie_num]=percent;

  global_pie_num ++;

  return global_pie_num - 1; 

}

/////////////////////////////////////////////////////
//
////////////////////////////////////////////////////
void gdx_setlabelbg(char *filename, int format, int label_id)
{
     XGCValues PM_prop;
     Pixmap mask, pm, pmP;
     XpmColorSymbol xpmcolor[1];

     attributes_bg.valuemask = XpmColormap;
     attributes_bg.x_hotspot = 0;
     attributes_bg.y_hotspot = 0;
     attributes_bg.depth = DefaultDepth(display, DefaultScreen(display));;
     attributes_bg.colormap = DefaultColormap(display, DefaultScreen(display));

     PM_prop.function = GXcopy;
     PM_prop.plane_mask = AllPlanes;
     PM_prop.foreground = 0;

     gcP_label[label_id] = XCreateGC(display, wlabel[label_id], GCForeground|GCFunction|GCPlaneMask, &PM_prop);

     attributes_bg.valuemask = XpmSize;

     XpmReadFileToPixmap(display,wlabel[label_id],filename,&pmP,&mask,&attributes_bg);

     XSetFillStyle(display, gcP_label[label_id], FillTiled);
     XSetTile(display, gcP_label[label_id], pmP);

     //if not tiled apply mask
     if(format==0){
        XSetClipMask(display,gcP_label[label_id],mask);
        labeltile[label_id]=0;
     }
     else{
        labeltile[label_id]=1;
     }

     imagew=attributes_bg.width;
     imageh=attributes_bg.height;

     //let the event manager know
     backgroundlabel_pixmap[label_id]=1;

}



