//////////////////////////////
// add_event.c
// written by Michael Gibson
// released under the GPL
// enter the event
// copyright 2007
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"


char *error_msg;

////////////////////////
//// error message
////////////////////////
void quick_message(void) {

  x_msgbox(5,error_msg,"Error","fixed",50);

}

 void readfile(void);
 void writefile(void);

 char indi_evendate_s[90];
 int  indi_evendate;
 char indi_evenplac_s[90];
 int  indi_evenplac;
 char indi_evennote_s[90];
 int  indi_evennote;

 int indi_i;
 char filename[55];
 char temp[99];               //data that is read in and evaluated

 int number_of_lines;
 int x; //loop var

 //for up to 99999 lines read in at the length up to 99
 char data_line[99999][99];

////////////////////////////////////////
//
//////////////////////////////////////
static void submit(void)
{

  char string_1[50];

  //printf("submit pressed \n");

  writefile();

  gdx_closewindow();
  exit(0);
}

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}


//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){



  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03;
  int label0,label1,label2,label3,label4,label5;
  char label_string1[60];
  char label_string2[60];
  int flag1=0;
  int x=0;
  int line=5;

  int loopy=0;

  FILE *fp;

  strcpy(filename, argv[2]);
  readfile();

  //printf("Start GUI\n");

  system("killall gedtree");
  x_open();

  /* create a new window */
  gdx_window("GEDCOM Add Event",500,200);
  gdx_setwindowbg("images/bg.xpm",1);

  button_01 = gdx_imagebutton(5,25,"images/close.xpm",destroy);
  button_02 = gdx_imagebutton(5,50,"images/filesave.xpm",submit);
  button_03 = gdx_imagebutton(35,160,"images/submit.xpm",submit);

  sprintf(label_string1,"Saving to filename %s",argv[2]);
  label0 = gdx_label(label_string1,40,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);


  printf("app=%s id=%s filename=%s \n",argv[0],argv[1],argv[2]);

  indi_i=atoi(argv[1]);
  

  // entry 

  label1=gdx_label("Add a special event for an individual",35,35,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);

  label2=gdx_label("Not genealogical events like birth, marriage, death, ect..", 35,60,0);
  gdx_setlabelbg("images/yellow.xpm",1,label2);

  label3=gdx_label("Event Date:",35,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label3); 
  indi_evendate=gdx_textentry(125,75,100,0);

  label4 = gdx_label("Event Place:",35,110,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_evenplac=gdx_textentry(125,100,350,0);

  label5 = gdx_label("Event Note:",35,135,0);
  gdx_setlabelbg("images/bg.xpm",1,label5);
  indi_evennote=gdx_textentry(125,125,350,0);


  gdx_main();
  x_close();

  return(0);
}


////////////////////////////////////////////////////////
// read file
////////////////////////////////////////////////////////

void readfile(void)
{

  int theend=0;      //if end of data found, stop reading

  int familyfound=0; //if a family is found, stop looking

  FILE *fp; 
  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM add parent : Sorry, no file found. \n");
     exit(0);
  }
  number_of_lines = 0;
  do{
    fgets(temp,99,fp);
    number_of_lines++;
    strcpy(data_line[number_of_lines],temp);

    //clean up returns
    for(x=0;x<80;x++){
      if(temp[x]=='\r' || temp[x]=='\n'){
         temp[x]= ' ';
      }
    }

   //find end
   if(temp[0] == '0' && temp[2] == 'T' && temp[3] == 'R'){
     theend=1;
   }
  //printf(".");

  }while (theend != 1); //end do
  fclose (fp);
}


//////////////////////////////
//
/////////////////////////////
void writefile(void)
{

  FILE *fp;

  char check_string1[15];
  char check_string2[15];

  int y; // loop var

  char indi[10];
  int indi_r;
  int grab_sex=0;

  int do_not_save=0;

  //collect data from text entry widgets

  strcpy(indi_evendate_s, gdx_textentry_obj.string[indi_evendate]);

  if(indi_evendate_s[0] >= 47 && indi_evendate_s[0]<= 56 || indi_evendate_s[0] == '\0'){
    //do_not_save=0; 
    printf(" ");
  }
  else{
       error_msg = "Did not save data - could not write Event Date.  Valid format is: DD MMM YYYY  Example: 10 Jan 1905";
       quick_message();
       do_not_save=1;
  }
  strcpy(indi_evenplac_s, gdx_textentry_obj.string[indi_evenplac]);
  strcpy(indi_evennote_s, gdx_textentry_obj.string[indi_evennote]);


if(do_not_save==0){

  //format the new data to write
  //format:
  // 0 @I0001@ INDI
  // 1 NAME Billy Bob /Johnson/
  // 1 SEX M
  // 1 EVEN
  // 2 DATE 10 Jun 1959
  // 2 PLAC some place here
  // 2 NOTE some note here


  if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add event : Sorry, no file found. \n");
     exit(0);
  }


  //write data
  for(x=1;x<=number_of_lines;x++){

    strcpy(temp,data_line[x]);


    //0123456789 
    //0 @I0007@
    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){
      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual ?
      if(indi_r == indi_i) grab_sex=1;
      else grab_sex=0;
    }
    //01234567
    //1 SEX M
    if(temp[0]=='1' && temp[2]=='S' && temp[3]=='E' && grab_sex==1){
        //if yes, add event
        sprintf(data_line[x],"%s1 EVEN\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_evendate_s,indi_evenplac_s,indi_evennote_s);
    }
    //write_data
   // printf("line %d ::%s::",x,data_line[x]);
    fprintf(fp,"%s",data_line[x]);
  }//end for
  fclose(fp);
}// end if can write
}
