//ged verify 
//tested against Ftree, EasyTree, and others
//0.1.0  initial release 
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *r_version="0.7.5";

void print_report(void);

char filename[50];
char temp[50];
int number_of_names=0;
int lines_of_data=0;
int x=0, y=0;
char option='a';
FILE *fp;

//////////////////////////////////////////
/// int main()
/////////////////////////////////////////
int main(int argc, char **argv)
{
  if(argc==2 || argc==3){
    if(argv[1][0]=='-'){
      option=argv[1][1];
    }
    else{
       printf("GEDCOM Verify: Sorry, no flag specified.\nFor more information type: gedverify -h\n");
       return(0);
    }
  }
  else{
     printf("GEDCOM Verify: Sorry, no flag specified.\nFor more information type: gedverify -h\n");
     return(0);
  }
  
  if(argc==3){
    sprintf(filename,"%s",argv[2]);
  }

  if(option =='h' ){
     printf("\nGEDCOM Verify %s (c)2003-2007 Michael Gibson mike@mrgibson.com\n",r_version);
     printf("gedverify -b|-h|-s|-t gedfile \n");
     printf("\n-s Stats\n-h This help\n");
     printf("-t Header info\n");
     return(0);
  }

  if(option != 'h' && option != 's' && option != 't' && option != 'b'){
     printf("GEDCOM Verify: Sorry, no valid flag specified.\nFor more information type: gedverify -h\n");
     return(0);
  }

  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM Verify: Sorry, no file found. \n");
     exit(0);
  }

  print_report();
  return(0);
}

//////////////////////////////////////////
/// print_report()
/////////////////////////////////////////
void print_report()
{

do{
  fgets(temp,80,fp);
  if(strstr(temp,"0 HEAD") != '\0' ){     ///0 HEAD
    printf("Verified GEDCOM has HEAD tag at line %d.\n\n",lines_of_data + 1);
  }
  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A'){     ///1 NAME
     number_of_names++;
  }
  if(temp[0]=='1' && temp[2]=='S' && temp[3]=='O' && temp[4]== 'R'){ //1 SOUR
     if(option=='t') printf("Source of GEDCOM is %s\n",temp);
  }
  if(temp[0]=='2' && temp[2]=='N' && temp[3]=='A'){ //2 NAME
     if(option=='t') printf("GEDCOM Source Name = %s\n",temp);
  }
  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='A'){ //1 DATE
     if(option=='t') printf("GEDCOM Date = %s\n",temp);
  }
  if(temp[0]=='2' && temp[2]=='T' && temp[3]=='I'){ //2 TIME
     if(option=='t') printf("GEDCOM Time = %s\n",temp);
  }

  if(temp[0]=='1' && temp[2]=='F' && temp[3]=='I'){ //1 FILE
     if(option=='t') printf("GEDCOM FILE = %s\n",temp);
  }
  lines_of_data++;
}while(temp[0] !='0' || temp[2] !='T');
printf("Verified GEDCOM has trailer tag.\n");
fclose(fp);
if(option=='s'){
  printf(" Number of Individuals in GED  = %d\n",number_of_names);
  printf(" Lines of Data in GED = %d\n",lines_of_data);
  number_of_names=number_of_names-1;
}

}

